#include <SoftwareSerial.h>
#include <LiquidCrystal.h>
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

int lightPin = 13;
int flamePin = A5;
int buzzer = 6;
int relay = 7;
int tempsensor=A0;


SoftwareSerial mySerial(9, 10);

void setup()
{
  pinMode (lightPin, OUTPUT) ;// define LED as output interface
  pinMode (A5, INPUT) ;// Intput interface is defined
  pinMode (relay, OUTPUT);
   pinMode (tempsensor, INPUT);
  pinMode (buzzer, OUTPUT) ;// output interface is defined
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
  lcd.print("Fire-Temp Alarm");
  delay(1000);
  Serial.begin(9600);
  
  mySerial.begin(9600);   // Setting the baud rate of GSM Module  
  Serial.begin(9600);    // Setting the baud rate of Serial Monitor (Arduino)
  delay(100);
}

void SendMessage()
{
  while(1){
  int analogValue = analogRead(flamePin);
  int analogValue1 = analogRead(tempsensor);

  int sensorValue=analogRead(A0);
  double V=sensorValue;
  double l= (V/1023)*500;
  int Temp=l;

   if (analogValue<500 || Temp> 40)
 {

     
        
      delay(1000);
         mySerial.println("AT+CMGF=1");    //Sets the GSM Module in Text Mode
  delay(1000);  // Delay of 1000 milli seconds or 1 second
  mySerial.println("AT+CMGS=\"+91xxxxxxxxxx\"\r"); // Replace x with your mobile number
  delay(1000);
  mySerial.println("Alert! Something unusual in the field!");// The SMS text you want to send

  delay(1000);
   mySerial.println((char)26);// ASCII code of CTRL+Z
  delay(1000);
      digitalWrite(lightPin, 1);
      Serial.println(analogValue);
      Serial.println(Temp);
      Serial.println("DANGER !!!");
      digitalWrite(buzzer,1);
      digitalWrite(relay,1);
      delay(1000);






      
     //  double Temp = log(10000.0*((1024.0/analogValue1-1))); 
 // Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp );
  
  lcd.setCursor(0, 0);
  lcd.print("DANGER !!!");
  lcd.setCursor(0, 1);
      lcd.print("Temp  : ");
    lcd.print(Temp);
    lcd.print("C");
    delay(2000);
    lcd.clear();
  int Temp1 = Temp + 273;            // Convert Kelvin to Celcius

    lcd.setCursor(0, 0);
  lcd.print("DANGER !!!");
  lcd.setCursor(0, 1);
      lcd.print("Temp   : ");
    lcd.print(Temp1);
    lcd.print("K");
    delay(2000);
    lcd.clear();
    
 int Temp2 = (Temp * 9.0)/ 5.0 + 32.0; // Convert Celcius to Farheniet

     lcd.setCursor(0, 0);
  lcd.print("DANGER !!!");
   lcd.setCursor(0, 1);
      lcd.print("Temp  : ");
    lcd.print(Temp2);
    lcd.print("F");
    delay(2000);
    lcd.clear();

    
     lcd.setCursor(0, 0);
  lcd.print("DANGER !!!");
       lcd.setCursor(0, 1);
    lcd.print("Flame :");
    lcd.print(analogValue);
      delay(2000);

     
 }

  
   else {
    
      digitalWrite(lightPin,0);
      digitalWrite(buzzer,0);
      digitalWrite(relay,0);
      delay(500);
      Serial.println("NORMAL!!!");
      digitalWrite(buzzer,0);
      Serial.println(analogValue);
      Serial.println(Temp);
 // double Temp = log(10000.0*((1024.0/analogValue1-1))); 
 // Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp );
   lcd.clear();
   lcd.setCursor(0, 0);
   lcd.print("NORMAL");
   lcd.setCursor(0, 1);
      lcd.print("Temp  : ");
    lcd.print(Temp);
    lcd.print("C");
    delay(2000);
    lcd.clear();
  int Temp1 = Temp + 273;            // Convert Kelvin to Celcius

    lcd.setCursor(0, 0);
  lcd.print("NORMAL");
  lcd.setCursor(0, 1);
      lcd.print("Temp   : ");
    lcd.print(Temp1);
    lcd.print("K");
    delay(2000);
    lcd.clear();
    
 int Temp2 = (Temp * 9.0)/ 5.0 + 32.0; // Convert Celcius to Farheniet

     lcd.setCursor(0, 0);
  lcd.print("NORMAL");
   lcd.setCursor(0, 1);
      lcd.print("Temp  : ");
    lcd.print(Temp2);
    lcd.print("F");
    delay(2000);
    lcd.clear();

    
     lcd.setCursor(0, 0);
  lcd.print("NORMAL");
       lcd.setCursor(0, 1);
    lcd.print("Flame :");
    lcd.print(analogValue);
      delay(2000);

    


      }
      
  }
   }




 void RecieveMessage()
{
  mySerial.println("AT+CNMI=2,2,0,0,0"); // AT Command to receive a live SMS
  delay(1000);
 }

 void loop()
{
 if (Serial.available()>0)
 switch(Serial.read())
  {
    case 's':SendMessage();
      break;
    case 'r':
      RecieveMessage();
      break;
  }
      
 if (mySerial.available()>0)
  Serial.write(mySerial.read());
}
